C--------------------------------------------------------------------
C     CALCULATE FUNCTION CONSTRAINT,RFACT AND WRFACT.
C--------------------------------------------------------------------
C
      SUBROUTINE CCALCON(ngsw,conF,conA,conG,wrfact,rfact,connew,
     $   mref,nrefF,nrefA,nrefG,FCAL,PROF,FOBS,SIGF,
     $   AOBS,SIGA,COSPSI,SINPSI,GCAL,GOBS,SIGG )
C
      IMPLICIT none
      integer ngsw,mref,nrefF,nrefA,nrefG,iref,jref
      real*8 conF,conA,conG,wrfact,rfact,connew,tnref
      real*8 FCAL(2,mref),PROF(mref),FOBS(2,mref),SIGF(mref),
     $  AOBS(2,mref),SIGA(2,mref),COSPSI(mref),SINPSI(mref),
     $  GCAL(mref/2),GOBS(mref/2),SIGG(mref/2)
      real*8 bs1,bb1,bs2,bb2,er,ed2,eo2,ed2a,eo2a,c,sa,ac
      real*8 ei,ed2b,eo2b,sb,bc
C
      conF=0.0
      conA=0.0
      conG=0.0
      bs1=0.0
      bb1=0.0
      bs2=0.0
      bb2=0.0
C
C*** CALCULATE F-TYPE CONSTRAINT FUNCTION. ***
C
      DO 10 iref=1,nrefF
         ER=FCAL(1,iref)*PROF(iref)-FOBS(1,iref)
         EI=FCAL(2,iref)*PROF(iref)-FOBS(2,iref)
         ed2=ER*ER
     $       +EI*EI
         eo2=FOBS(1,iref)**2
     $       +FOBS(2,iref)**2
         c = ed2/SIGF(iref)
         conF=conF+c
         bs1=bs1+c
         bb1=bb1+eo2/SIGF(iref)
         bs2=bs2+DSQRT(ed2)
         bb2=bb2+DSQRT(eo2)
   10 CONTINUE
      if (nrefF.gt.0) conF=conF/nrefF
C
C
C*** CALCULATE A-TYPE CONSTRAINT FUNCTION. ***
C
      DO 15 iref=1,nrefA
         jref=nrefF+iref
         ac=FCAL(1,jref)*PROF(jref)*COSPSI(iref)
     $     + FCAL(2,jref)*PROF(jref)*SINPSI(iref) 
         bc=sqrt((-FCAL(1,jref)*PROF(jref)*SINPSI(iref)
     $           + FCAL(2,jref)*PROF(jref)*COSPSI(iref) )**2 )
         er=ac-AOBS(1,iref)
         ei=bc-AOBS(2,iref)
         ed2a=er*er
         ed2b=ei*ei
         eo2a=AOBS(1,iref)**2
         eo2b=AOBS(2,iref)**2
         sa=SIGA(1,iref)
         sb=SIGA(2,iref)
         c = ed2a/sa
     $      + ed2b/sb
         conA=conA + c
         bs1=bs1 + c
         bb1=bb1+eo2a/sa
     $          +eo2b/sb
         bs2=bs2+DSQRT(ed2a
     $                 +ed2b
     $                 )
         bb2=bb2+DSQRT(eo2a
     $                 +eo2b
     $                 )
   15 CONTINUE
      if (nrefA.gt.0) conA=conA/nrefA
C
C
C*** CALCULATE G-TYPE CONSTRAINT FUNCTION. ***
C
      DO 20 iref=1,nrefG
         ed2=(GCAL(iref)-GOBS(iref))**2
         eo2=GOBS(iref)**2
         sa=SIGG(iref)
         conG=conG+ed2/sa
         bs1=bs1+ed2/sa
         bb1=bb1+eo2/sa
         bs2=bs2+DSQRT(ed2)
         bb2=bb2+DSQRT(eo2)
   20 CONTINUE
         if (nrefG.gt.0) conG=conG/nrefG
C
C*** CALCULATE R-FACTOR AND COMBINED CONSTRAINT FUNCTION ***
C
      wrfact=DSQRT(bs1/bb1)
      rfact=bs2/bb2
      connew= conF+conA+conG
C
      RETURN
      END
C
