C--------------------------------------------------------------------
C     CALCULATE STRUCTURE FACTORS. ( TYPE-G ) from F_calc
C--------------------------------------------------------------------
C
C*   GOBS(1..nrefG) contains the mean |F| of G-constraints
C*     SIGG(1..nrefG) contains the sigma of Gobs of group j   
C*     NGRP(1..nrefG) contains the number of reflections in group j   
C*     PMUL(1..nrefG+..) contains the multiplicity of reflections in groups 
C*     PMULS(1..nrefG) contains the sum of the multiplicities of group j    
C*   nrefF,nrefA,nrefG contain the numbers of constraints: F, A, G
C*   nref=total number of reflections
C*   FCAL(1..2,1..nref) contains the calculated A and B of ALL constraints
C*   GCAL(1..nrefG) contains the calculated |G| of the G-constraints
C*        gcal=sqrt( sum(reflections of one group: m_i * |F_i|^2) /
C*                     sum(refl. of one group: m_j)                )
C
      SUBROUTINE CSTRCTG( mref,nrefF,nrefA,nrefG,FCAL,GCAL,
     $                   PROF,NGRP,PMUL,PMULS)
C
      implicit none
      integer iref,jref,mref,nref,nrefF,nrefA,nrefG,NGRP(mref/2)
      integer nrefFA,igrp
      real*8  FCAL(2,mref),GCAl(mref/2),PROF(mref)
     $       ,PMUL(mref/2),PMULS(mref/2),gg
C
      nrefFA=nrefF+nrefA
      jref=nrefFA+1
      DO 30 iref=1,nrefG
         gg=0.0
         DO 35 igrp=1,NGRP(iref)
            gg=gg+PMUL(jref-nrefFA)*(
     $      (FCAL(1,jref)*PROF(jref))**2
     $      +(FCAL(2,jref)*PROF(jref))**2
     $      )
            jref=jref+1
   35    CONTINUE
         GCAL(iref)=DSQRT(gg/PMULS(iref))
   30 CONTINUE
C
      RETURN
      END
