C     *************************************
C     *   DISPLAY RESULT OF CALCULATIONS  *
C     *************************************
C
      SUBROUTINE dspresul(ifile,
     $  connew,conF,conA,conG,delta,rfact,wrfact,ents,entj,qfunc,
     $  IHIST,FHIST,mhist,nhist,iptyp,itcycl,COSPSI,SINPSI,
     $  mref,nrefF,nrefA,nrefG,FOBS,SIGF,FCAL,PROF,AOBS,SIGA,
     $  NGRP,GOBS,SIGG,GCAL,IDX)
C
      IMPLICIT  none
C
C     *** variables connected with the structure factors given as input:
C*
C*   IDX(1..3,1..nref) contains the hkl-indices of ALL reflections
C*   FOBS(1..2,1..nrefF) contains the A and B of F-constraints
C*     SIGF(1..nrefF) contains the ( sigma(|F|) )^2 of the F-constraints
C*   AOBS(1..2,1..nrefA) contains the A and |B| of A-constraints 
C*     SIGA(1..2,1..nrefA) contains the (sigma(A))^2 and (sigma(|B|))^2 
C      of the A-constraints.
C*     COSPSI(1..nrefA),SINPSI(1..nrefA) contain the phase angles of the
C*       structure factor of the sub-structure of the anomalous scatterer
C*       for the A-constraints reflections
C*   GOBS(1..nrefG) contains the mean |F| of G-constraints
C*     SIGG(1..nrefG) contains the (sigma)^2 of Gobs of group j   
C*     NGRP(1..nrefG) contains the number of reflections in group j
C*     PMUL(1..nrefG+..) contains the multiplicity of reflections in groups
C*     PMULS(1..nrefG) contains the sum of the multiplicities of group j
C*   nrefF,nrefA,nrefG contain the numbers of constraints: F, A, G
C*   nref=total number of reflections
C*   FCAL(1..2,1..nref) contains the calculated A and B of ALL reflections
C*   GCAL(1..nrefG) contains the calculated |G| of the G-constraints
C
      integer mref,nrefF,nrefA,nrefG
      real*8 connew,conF,conA,conG,delta,rfact,wrfact,ents,entj,qfunc
      real*8 FOBS(2,mref),FCAL(2,mref),SIGF(mref),
     $  GCAL(mref/2),SIGG(mref/2),PROF(mref),GOBS(mref/2),
     $  AOBS(2,mref),SIGA(2,mref),COSPSI(mref),SINPSI(mref)
      integer IDX(3,mref),NGRP(mref/2),itcycl
      real*8 dev,devA,devB
C
C     *** variables connected with lambda-history list:
      integer mhist,nhist,IHIST(mhist)
      real*8 FHIST(3,mhist)
C
      integer i,j,k,igrp,jh,jk,jl,iref,jref,iptyp,ifile
      real*8 fcpr,fcpi,ac,bc
C
 3030 FORMAT( /'  con=',F13.4,' conF=',F13.4,' conA=',F13.4,
     $         ' conG=',F13.4
     $        /' DELT=',F16.7,'    R=',F16.7,'   WR=',F16.7)
 3040 FORMAT(  ' ENTS=',F16.7,' ENTJ=',F16.7,' LAGR=',F16.7)
 3050 FORMAT('*********   FINAL RESULT OF MEED ANALYSIS   *******',
     $       '*************************',
     $        /' Number of cycles calculated:', i6)
 3065 FORMAT(/'*********   HISTORY OF CHANGING LAMBDA  ***********',
     $       '*************************',/,' ')
 3070 FORMAT(  ' CYCLE=',I5,
     +         ',  LAMBDA=',F10.7,' --> ',F10.7,', CON=',F15.3) 
C
C *** Fobs-list with preferred orientation ***
C
 3080 FORMAT(//' *********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'   H   K   L ',5X,'FOBS',18X,
     $ 'FCAL*P',16X,'FCAL','                  dev.')
C
C *** Fobs-list without preferred orientation ***
C
 3081 FORMAT(//' *********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'   H   K   L ',5X,'FOBS',18X,
     $ 'FCAL','                 dev.')
C                  hkl    Fobs  Fcal*p  Fcal  dev
 3090 FORMAT(' ',3(I3,1X),6F11.4,1X,f7.2)       !Fobs with p.o.
C                  hkl    Fobs  Fcal  dev
 3091 FORMAT(' ',3(I3,1X),4F11.4,1X,f7.2)       !Fobs without p.o.
C
C *** Aobs-list ***
C
 3086 FORMAT(/'*********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'   H   K   L ',5X,'AOBS',18X,
     $ 'ACAL',18X,'FCAL','                  devA    devB')
C                  hkl    Aobs  Acal  Fcal  devA,devB
 3087 FORMAT(' ',3(I3,1X),6F11.4,1X,f7.2,2X,f7.2)    
C
C *** Gobs-list ***
C
 3100 FORMAT(/'   H   K   L ',
     $   5X,'GOBS',9X,'GCAL',11X,'FCAL',18x,'dev.')
C *** for Gobs-list: first line of a group
C                 hkl     Gcal     Gobs     Fcal      dev
 3110 FORMAT(' ',3(I3,1X),F11.4,2X,F11.4,4X,2F11.4,2X,f7.2)
C *** for Gobs-list: following lines
C                 hkl        Fcal
 3115 FORMAT(' ',3(I3,1X),28X,2F11.4)
C
C 3120 FORMAT(/' *********   END OF MEED ANALYSIS  DATE ',2A4,'  TI',
C     $       'ME ',2A4,'   ***********',3(/' '))
 3120 FORMAT(/' *********   END OF MEED ANALYSIS   ***********',
     $       1(/' '))
C
      WRITE(ifile,3050) itcycl
      WRITE(ifile,3030) connew,conF,conA,conG,delta,rfact,wrfact
      WRITE(ifile,3040) ents,entj,qfunc
      IF (NHIST.gt.0) THEN
         WRITE(ifile,3065)
         do 710 j=1,nhist
           WRITE(ifile,3070) IHIST(j),(FHIST(k,j),k=1,3)
710      continue 
      END IF
C
C***** F-constraints ***
C
      if (iptyp.ge.0) then
        WRITE(ifile,3080)	!with preferred orientation
      else
        write(ifile,3081)	!without p.o.
      endif
      DO 80 iref=1,nrefF
         JH=IDX(1,iref)
         JK=IDX(2,iref)
         JL=IDX(3,iref)
         fcpr=FCAL(1,iref)*PROF(iref)
         fcpi=FCAL(2,iref)*PROF(iref)
         dev=( sqrt( fcpr**2 + fcpi**2 ) -
     $         sqrt( FOBS(1,iref)**2 + FOBS(2,iref)**2 )
     $        )/sqrt(SIGF(iref))
	 if (iptyp.ge.0) then	!with preferred orientation ***
           WRITE(ifile,3091) JH,JK,JL,
     $       (FOBS(j,iref),j=1,2),fcpr,fcpi,
     $       (FCAL(j,iref),j=1,2),dev
	 else
           WRITE(ifile,3090) jh,jk,jl,
     $       (FOBS(j,iref),j=1,2),
     $       (FCAL(j,iref),j=1,2),dev
	 endif  
   80 CONTINUE
      write(ifile,*)
     $   'Relative deviation dev=(|Fcal|-|Fobs|)/sigma(|F|)'
C
C***** A-constraints ***
C
      IF (nrefA.EQ.0) GO TO 260
      write(ifile,3086)
      DO 85 iref=1,nrefA
         jref=nrefF+iref
         JH=IDX(1,jref)
         JK=IDX(2,jref)
         JL=IDX(3,jref)
         ac= FCAL(1,jref)*COSPSI(iref)+FCAL(2,jref)*SINPSI(iref)
         bc=-FCAL(1,jref)*SINPSI(iref)+FCAL(2,jref)*COSPSI(iref)
         devA=(ac     -AOBS(1,iref))/sqrt(SIGA(1,iref))
         devB=(abs(bc)-AOBS(2,iref))/sqrt(SIGA(2,iref))
         WRITE(ifile,3087) jh,jk,jl,(AOBS(j,iref),j=1,2),
     $     ac,bc,(FCAL(j,jref),j=1,2),devA,devB
   85 CONTINUE
      write(ifile,*) 
     $   'Relative deviations devA=(Acal-Aobs)/sigma(A),',
     $   ' devB=(|Bcal|-|Bobs|)/sigma(B)'
C
C***** G-constraints ***
C
  260 IF (nrefG.le.0) GO TO 270
      jref=nrefF+nrefA+1
      WRITE(ifile,3100)
      DO 90 iref=1,nrefG
         dev= ( GCAL(iref)-GOBS(iref) )/sqrt(SIGG(iref))
         DO 90 IGRP=1,NGRP(iref)
            JH=IDX(1,jref)
            JK=IDX(2,jref)
            JL=IDX(3,jref)
            IF (igrp.EQ.1) THEN
               WRITE(ifile,3110)
     $         JH,JK,JL,GOBS(iref),GCAL(iref),
     $         (FCAL(J,jref),J=1,2), dev
            ELSE
               WRITE(ifile,3115) JH,JK,JL,(FCAL(J,jref),J=1,2)
            END IF
            jref=jref+1
   90 continue
      write(ifile,*)
     $   'Relative deviation dev=(Gcal-Gobs)/sigma(G)'
  270 WRITE(ifile,3120) 
      return
      end
